"
 COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

MessageNode subclass:#BinaryNode
       instanceVariableNames:''
       classVariableNames:''
       poolDictionaries:''
       category:'System-Compiler-Support'
!

BinaryNode comment:'
COPYRIGHT (c) 1989 by Claus Gittinger
              All Rights Reserved

$Header: /cvs/stx/stx/libcomp/BinaryNode.st,v 1.5 1994-01-16 03:51:32 claus Exp $
'!

!BinaryNode methodsFor:'queries'!

isBinaryMessage
    ^ true
! !

!BinaryNode methodsFor:'accessing'!

arg
    ^ argArray at:1
! !

!BinaryNode methodsFor:'evaluating'!

evaluate
    receiver isSuper ifTrue:[
        ^ super evaluate
    ].
    ^ (receiver evaluate) perform:selector with:(argArray at:1) evaluate
! !

!BinaryNode methodsFor:'code generation'!

codeOn:aStream inBlock:b
    |arg1|

    (receiver type == #Super) ifFalse:[
        ( #(== ~~ = ~= + - < <= > >=) includes:selector) ifTrue:[
            receiver codeOn:aStream inBlock:b.
            arg1 := argArray at:1.
            arg1 isConstant ifTrue:[
                (arg1 type == #Integer) ifTrue:[
                    ((selector == #==) or:[selector == #~~]) ifTrue:[
                        (arg1 value == 0) ifTrue:[
                            (selector == #==) ifTrue:[
                                aStream nextPut:#eq0
                            ] ifFalse:[
                                aStream nextPut:#ne0
                            ].
                            ^ self
                        ]
                    ].
                    ((selector == #+) or:[selector == #-]) ifTrue:[
                        (arg1 value == 1) ifTrue:[
                            (selector == #+) ifTrue:[
                                aStream nextPut:#plus1
                            ] ifFalse:[
                                aStream nextPut:#minus1
                            ].
                            aStream nextPut:lineNr.
                            ^ self
                        ]
                    ]
                ]
            ].
            arg1 codeOn:aStream inBlock:b.
            aStream nextPut:selector.
            (self class hasLineNumber:selector) ifTrue:[
                aStream nextPut:lineNr.
            ].
            ^ self
        ]
    ].
    ^ super codeOn:aStream inBlock:b
! !

!BinaryNode methodsFor:'printing'!

printOn:aStream indent:i
    |needParen|

    needParen := false.
    receiver isMessage ifTrue:[
        receiver isUnaryMessage ifFalse:[
            needParen := true
        ].
    ].
    needParen ifTrue:[
        aStream nextPutAll:'('
    ].
    receiver printOn:aStream.
    needParen ifTrue:[
        aStream nextPutAll:') '
    ].

    aStream space.
    selector printString printOn:aStream.
    aStream space.

    needParen := false.
    self arg isMessage ifTrue:[
        self arg isUnaryMessage ifFalse:[
            needParen := true
        ].
    ].
    needParen ifTrue:[
        aStream nextPutAll:'('
    ].
    self arg printOn:aStream.
    needParen ifTrue:[
        aStream nextPutAll:') '
    ].
! !
